Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1830680

Summary: FTI: python-parallel-ssh: python3-parallel-ssh
Product: [Fedora] Fedora Reporter: Igor Raits <igor.raits>
Component: python-parallel-sshAssignee: Raphael Groner <projects.rg>
Status: ASSIGNED --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: igor.raits, mhroncok, projects.rg
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1875392, 1723169, 1877240    
Bug Blocks: 1750909, 1803235, 1868279, 1868963, 1927313, 1770844, 1898136    

Description Igor Raits 2020-05-03 09:48:01 UTC
Hello,

Your package (python-parallel-ssh) Fails To Install in Fedora 33:

---
can't install python3-parallel-ssh-1.9.1-4.fc32.x86_64:
  - nothing provides python3.8dist(ssh2-python) >= 0.17 needed by python3-parallel-ssh-1.9.1-4.fc32.x86_64
---

According to a policy for FTBFS/FTI bugs (https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/), your package may be orphaned in 8+ weeks if you won't reply to this bug.

Thanks!

Comment 6 Fedora Admin user for bugzilla script actions 2020-06-30 14:56:50 UTC
This package has changed maintainer in the Fedora.
Reassigning to the new maintainer of this component.

Comment 7 Igor Raits 2020-07-01 08:44:24 UTC
This package has been orphaned.

You can pick it up at https://src.fedoraproject.org/rpms/python-parallel-ssh by clicking button "Take". If nobody picks it up, it will be retired and removed from a distribution.

Comment 8 Raphael Groner 2020-07-28 12:43:52 UTC
Package taken. Will see if I can fix FTBFS/FTI.

Comment 9 Raphael Groner 2020-08-09 16:36:50 UTC
The dependency ssh2-python (actually orphaned as well) needs the version update and to get fixed for python 3.9 first.
https://github.com/ParallelSSH/ssh2-python/pull/98

Comment 10 Miro Hrončok 2020-08-09 19:39:02 UTC
Suggestion: https://github.com/ParallelSSH/ssh2-python/pull/98 only rebuilds files with Cython. If that's what it takes, do it in %build.

Comment 11 Miro Hrončok 2020-08-09 19:54:29 UTC
The current problem here is:

Error: 
 Problem: conflicting requests
  - nothing provides python3.9dist(ssh2-python) >= 0.17 needed by python3-parallel-ssh-1.9.1-6.fc33.x86_64

Comment 12 Ben Cotton 2020-08-11 13:22:15 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 33 development cycle.
Changing version to 33.

Comment 13 Miro Hrončok 2020-08-18 12:07:28 UTC
I've heard Raphael is working on this.

Comment 14 Raphael Groner 2020-09-02 14:23:58 UTC
*** Bug 1871602 has been marked as a duplicate of this bug. ***

Comment 15 Raphael Groner 2020-09-02 14:27:08 UTC
*** Bug 1770844 has been marked as a duplicate of this bug. ***

Comment 16 Raphael Groner 2020-09-03 06:52:25 UTC
Trying to build ssh2-python version 0.17.0, is cython outdated?

ssh2/publickey.c: In function ‘__Pyx_modinit_type_init_code’:
ssh2/publickey.c:5446:44: error: ‘PyTypeObject’ {aka ‘struct _typeobject’} has no member named ‘tp_print’
 5446 |   __pyx_type_4ssh2_9publickey_PublicKeyList.tp_print = 0;
      |                                            ^
ssh2/publickey.c:5454:49: error: ‘PyTypeObject’ {aka ‘struct _typeobject’} has no member named ‘tp_print’
 5454 |   __pyx_type_4ssh2_9publickey_PublicKeyAttribute.tp_print = 0;
      |                                                 ^
ssh2/publickey.c:5462:46: error: ‘PyTypeObject’ {aka ‘struct _typeobject’} has no member named ‘tp_print’
 5462 |   __pyx_type_4ssh2_9publickey_PublicKeySystem.tp_print = 0;
      |                                              ^
ssh2/publickey.c: In function ‘__Pyx_ParseOptionalKeywords’:
ssh2/publickey.c:5866:21: warning: ‘_PyUnicode_get_wstr_length’ is deprecated [-Wdeprecated-declarations]
 5866 |                     (PyUnicode_GET_SIZE(**name) != PyUnicode_GET_SIZE(key)) ? 1 :
      |                     ^
In file included from /usr/include/python3.9/unicodeobject.h:1026,
                 from /usr/include/python3.9/Python.h:97,
                 from ssh2/publickey.c:4:
/usr/include/python3.9/cpython/unicodeobject.h:446:26: note: declared here
  446 | static inline Py_ssize_t _PyUnicode_get_wstr_length(PyObject *op) {
      |                          ^~~~~~~~~~~~~~~~~~~~~~~~~~
ssh2/publickey.c:5866:21: warning: ‘PyUnicode_AsUnicode’ is deprecated [-Wdeprecated-declarations]
 5866 |                     (PyUnicode_GET_SIZE(**name) != PyUnicode_GET_SIZE(key)) ? 1 :
      |                     ^

Comment 17 Miro Hrončok 2020-09-03 06:57:09 UTC
Is ssh2/publickey.c regenerated at build time?

Comment 18 Raphael Groner 2020-09-03 08:55:53 UTC
(In reply to Miro Hrončok from comment #17)
> Is ssh2/publickey.c regenerated at build time?

I tried with the embedded files but copy+pasted from official spec file of ssh2-python and I knoow it's not good practice. Will invest deeper.

Comment 19 Raphael Groner 2020-09-03 09:25:29 UTC
CMake Error at src/CMakeLists.txt:217 (add_library):
  Cannot find source file:
    openssl.c
  Tried extensions .c .C .c++ .cc .cpp .cxx .cu .m .M .mm .h .hh .h++ .hm
  .hpp .hxx .in .txx
CMake Error at example/CMakeLists.txt:68 (add_executable):
  Cannot find source file:
    sftp_write.c
  Tried extensions .c .C .c++ .cc .cpp .cxx .cu .m .M .mm .h .hh .h++ .hm
  .hpp .hxx .in .txx

Comment 20 Raphael Groner 2020-09-03 10:04:18 UTC
Please validate my recent changes pushed to pagure.

Comment 21 Miro Hrončok 2020-09-03 10:31:57 UTC
I don't understand your changes. Why are you building 2 Python packages from one spec file?

Comment 22 Raphael Groner 2020-09-08 04:58:34 UTC
*** Bug 1876639 has been marked as a duplicate of this bug. ***

Comment 23 Raphael Groner 2020-09-09 10:45:25 UTC
Obviously, python-ssh2-python needs an update due to version mismatch in API. Bundling could be a solution to prevent any further API breakage.

The package python-netssh2 depends too, bug #1877240 with review request for a mocked ssh could be an option to keep functionality with enabled %check. As I'm not maintainer there, I can try to file a pull request to enable execution of upstream's provided unit tests.

Comment 24 Ben Cotton 2021-02-09 15:14:58 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 25 Raphael Groner 2021-03-04 15:50:58 UTC
Does explicitly versioned BuildRequires overrule dependency generator? Going to add explicitly versioned Requires, too.

Comment 26 Miro Hrončok 2021-03-04 16:01:49 UTC
> Does explicitly versioned BuildRequires overrule dependency generator?

No.

Comment 27 Raphael Groner 2021-03-04 17:04:49 UTC
Okay, waiting for finally imported new package python-mockssh-server fully lands onto rawhide mirrors to be able to execute some tests in %check.

Version 0.26.0 of ssh2-python builds successfully, see bug #1875392 for >= 0.17.0 version need.

Failed try to bundle reverted in dist-git.